From 139ef29a7074fa0aa2df472134f67c3793f846e4 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Tue, 13 Dec 2022 10:59:32 +0530
Subject: [PATCH v1 05/25] Change brin_minmax_multi_summary_in to allow
 non-throw error reporting

---
 src/backend/access/brin/brin_minmax_multi.c |  2 +-
 src/test/regress/expected/type_sanity.out   | 12 ++++++++++++
 src/test/regress/sql/type_sanity.sql        |  3 +++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/backend/access/brin/brin_minmax_multi.c b/src/backend/access/brin/brin_minmax_multi.c
index 9a0bcf6698d..99ea7910c79 100644
--- a/src/backend/access/brin/brin_minmax_multi.c
+++ b/src/backend/access/brin/brin_minmax_multi.c
@@ -3003,7 +3003,7 @@ brin_minmax_multi_summary_in(PG_FUNCTION_ARGS)
 	 * brin_minmax_multi_summary stores the data in binary form and parsing
 	 * text input is not needed, so disallow this.
 	 */
-	ereport(ERROR,
+	ereturn(fcinfo->context, (Datum) 0,
 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			 errmsg("cannot accept a value of type %s", "brin_minmax_multi_summary")));
 
diff --git a/src/test/regress/expected/type_sanity.out b/src/test/regress/expected/type_sanity.out
index 95aa04e69ef..140dc6b948a 100644
--- a/src/test/regress/expected/type_sanity.out
+++ b/src/test/regress/expected/type_sanity.out
@@ -808,3 +808,15 @@ SELECT pg_input_error_message('1', 'pg_brin_bloom_summary');
  cannot accept a value of type pg_brin_bloom_summary
 (1 row)
 
+SELECT pg_input_is_valid('1', 'pg_brin_minmax_multi_summary');
+ pg_input_is_valid 
+-------------------
+ f
+(1 row)
+
+SELECT pg_input_error_message('1', 'pg_brin_minmax_multi_summary');
+                 pg_input_error_message                  
+---------------------------------------------------------
+ cannot accept a value of type brin_minmax_multi_summary
+(1 row)
+
diff --git a/src/test/regress/sql/type_sanity.sql b/src/test/regress/sql/type_sanity.sql
index a75f6abfd27..7c1aff8a65b 100644
--- a/src/test/regress/sql/type_sanity.sql
+++ b/src/test/regress/sql/type_sanity.sql
@@ -599,3 +599,6 @@ SELECT pg_input_error_message('pg_monitor=rY', 'aclitem');
 
 SELECT pg_input_is_valid('1', 'pg_brin_bloom_summary');
 SELECT pg_input_error_message('1', 'pg_brin_bloom_summary');
+
+SELECT pg_input_is_valid('1', 'pg_brin_minmax_multi_summary');
+SELECT pg_input_error_message('1', 'pg_brin_minmax_multi_summary');
-- 
2.18.0

